package com.aispeech.webhookdemo.controller;


import com.aispeech.webhookdemo.pojo.HuilvPojo;
import com.aispeech.webhookdemo.service.CurrencyConvert;
import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;


@RestController
public class Huilv {
    private Logger logger = LoggerFactory.getLogger(Huilv.class);
    @Autowired
    private CurrencyConvert convert;

    @PostMapping(path = "/webhook-demo/huilv/query", produces = {"application/json"})
    public JSONObject huilvQuery(@RequestBody HuilvPojo hp, @RequestParam(required = false) String productId,
                                 @RequestParam(required = false) String deviceName, @RequestParam(required = false) String RecordId,
                                 @RequestParam(required = false) String userId) {
        logger.info("productid:{},deviceName:{},recordid:{},userId:{}", productId, deviceName, RecordId, userId);
        String result = convert.convertCurrency(hp.getFrom(), hp.getTo(), hp.getFromNumber());
        logger.info("from:{},to:{},nunmber:{},result:{}", hp.getFrom(), hp.getTo(), hp.getFromNumber(), result);
        JSONObject o = new JSONObject();
        if (result.contains("该币种汇兑换算未启用")) {
            o.put("errorcode", "100200");
            o.put("errmsg", result);
        } else {
            JSONObject extra = new JSONObject();
            extra.put("from", hp.getFrom());
            extra.put("to", hp.getTo());
            extra.put("fromNumber", hp.getFromNumber());
            extra.put("result", result);
            o.put("extra", extra);
            o.put("errorcode", "100100");
        }
        return o;
    }
}
