package com.aispeech.webhookdemo.exception;

import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletResponse;


@ControllerAdvice
public class GlobalExceptionHandle {


    private Logger logger = LoggerFactory.getLogger(GlobalExceptionHandle.class);


    @ExceptionHandler(value = Exception.class)
    @ResponseBody
    public JSONObject exceptionHandler(Exception e, HttpServletResponse response) {
        logger.error("内部错误", e);
        JSONObject result = new JSONObject();
        result.put("errorcode", 100200);
        result.put("errmsg", "内部错误");
        return result;
    }
}
