package com.aispeech.webhookdemo.service.impl;

import com.aispeech.webhookdemo.conf.CurrencyConfig;
import com.aispeech.webhookdemo.service.CurrencyConvert;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.time.LocalDate;
import java.time.ZoneOffset;


@Service
public class CurrencyConvertImpl implements CurrencyConvert {
    private Logger logger = LoggerFactory.getLogger(CurrencyConvertImpl.class);
    @Autowired
    RestTemplate restTemplate;

    @Value("https://api.jijinhao.com/plus/convert.htm")
    private String huilvDataSourceUrl;

    private String getCurrencyCode(String name) {
        String currencyCode = CurrencyConfig.currencyMap.get(name);
        logger.info("name:{},code:{}", name, currencyCode);
        return currencyCode;
    }

    @Override
    public String convertCurrency(String from, String to, String number) {
        LocalDate dtNow = LocalDate.now();
        String suffix = String.format("?from_tkc=%s&to_tkc=%s&amount=%s&_=%d", getCurrencyCode(from), getCurrencyCode(to), number, dtNow.atStartOfDay(ZoneOffset.UTC).toInstant().toEpochMilli());
        String queryurl = huilvDataSourceUrl + suffix;
        String result = restTemplate.getForEntity(queryurl, String.class).getBody();
        logger.info("queryurl:{},result:{}", queryurl, result);
        String value = result.substring(result.indexOf("'") + 1, result.lastIndexOf("'"));
        return value;
    }
}
